<?php
/*  
 * Analysis Console for Incident Databases (ACID)
 *
 * Author: Roman Danyliw <rdd@cert.org>, <roman@danyliw.com>
 *
 * Copyright (C) 2000 Carnegie Mellon University
 * (see the file 'acid_main.php' for license details)
 *
 * Purpose:   
 *
 * Input GET/POST variables
 *   - submit:
 *   - time:
 *   - time_sep:
 */
?>

<?php
  include ("acid_conf.php");
  include ("acid_db.inc");
  include ("acid_db_common.php");
  include ("acid_common.php");
  include ("acid_graph_common.php");
?>

<?php
function StoreAlertNum($sql, $label, &$xdata, &$cnt, $min_threshold)
{  
  GLOBAL $db, $debug_mode;

  if ( $debug_mode > 0 )     echo $sql."<BR>";

  $result = $db->acidExecute($sql);
  if ( $myrow = $result->acidFetchRow() )
  {
     if ( $myrow[0] >= $min_threshold )
     {
        $xdata [ $cnt ][0] = $label;
        $xdata [ $cnt ][1] = $myrow[0];
     }
     $result->acidFreeRows();

     $cnt++;
  }
}

function GetTimeDataSet(&$xdata, $chart_type, $data_source, $min_threshold)
{
  GLOBAL $db, $debug_mode;

   if ( $debug_mode > 0 )
   {
      echo "chart_type = $chart_type<BR>
            data_source = $data_source<BR>";
   }

   $sql = "SELECT min(timestamp), max(timestamp) FROM event ".
          "INNER JOIN acid_ag_alert ".
          "ON (event.sid=acid_ag_alert.ag_sid AND event.cid=acid_ag_alert.ag_cid) ".
          "WHERE ag_id =".$data_source;
 
   echo $sql."<BR>";

   $result = $db->acidExecute($sql);
   $myrow = $result->acidFetchRow();
   $start_time = $myrow[0];
   $stop_time = $myrow[1];
   $result->acidFreeRows();

   $year_start  = date("Y", strtotime($start_time));
   $month_start = date("m", strtotime($start_time));
   $day_start   = date("d", strtotime($start_time));
   $hour_start  = date("H", strtotime($start_time));

   $year_end  = date("Y", strtotime($stop_time));
   $month_end = date("m", strtotime($stop_time));
   $day_end   = date("d", strtotime($stop_time));
   $hour_end  = date("H", strtotime($stop_time));

   switch($chart_type)
   { 
     case 1:  // hour
     { 
        $hour_start = 0; $hour_end = 23; 
        break;
     }
     case 2:  // day          
     { 
        $hour_start = -1;
        break; 
     }
     case 4:  // month           
     { 
        $day_start = -1;
        $hour_start = -1;
        break; 
     }
  }

  if ( $debug_mode > 0 )
  {
     echo '<TABLE BORDER=1>
            <TR>
              <TD>year_start<TD>year_end<TD>month_start<TD>month_end
              <TD>day_start<TD>day_end<TD>hour_start<TD>hour_end
            <TR>
              <TD>'.$year_start.'<TD>'.$year_end.'<TD>'.$month_start.'<TD>'.$month_end.
              '<TD>'.$day_start.'<TD>'.$day_end.'<TD>'.$hour_start.'<TD>'.$hour_end.
           '</TABLE>';
  }

  $cnt = 0;

  $ag = " INNER JOIN acid_ag_alert ON ".
        "(acid_ag_alert.ag_sid=event.sid AND acid_ag_alert.ag_cid=event.cid) ";
  $ag_criteria = " AND ag_id=$data_source";

  for ( $i_year = $year_start; $i_year <= $year_end; $i_year++ )
  {
      $sql = "SELECT count(*) FROM event $ag WHERE ".
             $db->acidSQL_YEAR("timestamp", "=", $i_year).$ag_criteria;

      if ( $month_start != -1 )
      {
         if ($i_year == $year_start)  $month_start2 = $month_start;  else  $month_start2 = 1;
         if ($i_year == $year_end)    $month_end2 = $month_end;      else  $month_end2 = 12;

         for ( $i_month = $month_start2; $i_month <= $month_end2; $i_month++ )
         {
             $sql = "SELECT count(*) FROM event $ag WHERE ".
                    $db->acidSQL_YEAR("timestamp", "=", $i_year)." AND ".
                    $db->acidSQL_MONTH("timestamp", "=", $i_month).$ag_criteria;

             if ( $day_start != -1 )
             {
                if ($i_month == $month_start)  $day_start2 = $day_start;  else  $day_start2 = 1;
                if ($i_month == $month_end)    $day_end2 = $day_end;      else  $day_end2 = 31;

                for ( $i_day = $day_start2; $i_day <= $day_end2; $i_day++ )
                {
                    $sql = "SELECT count(*) FROM event $ag WHERE ".
                           $db->acidSQL_YEAR("timestamp", "=", $i_year)." AND ".
                           $db->acidSQL_MONTH("timestamp", "=",$i_month)." AND ".
                           $db->acidSQL_DAY("timestamp", "=", $i_day).$ag_criteria;

                    if ( $hour_start != -1 )
                    {
                       for ( $i_hour = $hour_start; $i_hour <= $hour_end; $i_hour++ )
                       {
                           $sql = "SELECT count(*) FROM event $ag WHERE ".
                                  $db->acidSQL_YEAR("timestamp", "=", $i_year)." AND ".
                                  $db->acidSQL_MONTH("timestamp", "=", $i_month)." AND ".
                                  $db->acidSQL_DAY("timestamp", "=", $i_day)." AND ".
                                  $db->acidSQL_HOUR("timestamp", "=", $i_hour).$ag_criteria;

                           StoreAlertNum($sql, $i_month."/".$i_day."/".$i_year." ".
                                               $i_hour.":00:00 - ".$i_hour.":59:59", 
                                               $xdata, $cnt, $min_threshold);
                       }  // end hour
                    }
                    else
                        StoreAlertNum($sql, $i_month."/".$i_day."/".$i_year, 
                                      $xdata, $cnt, $min_threshold);
                }   // end day
             }
             else
               StoreAlertNum($sql, $i_month."/".$i_year, $xdata, $cnt, $min_threshold);
         }   // end month
      }
      else
        StoreAlertNum($sql, $i_year, $xdata, $cnt, $min_threshold);
  }   // end year

  return $cnt;
}

function GetIPDataSet(&$xdata, $chart_type, $data_source, $min_threshold)
{
  GLOBAL $db, $debug_mode;

   if ( $debug_mode > 0 )
   {
      echo "chart_type = $chart_type<BR>
            data_source = $data_source<BR>";
   }

   if ( $chart_type == 6 ) 
      $sql = "SELECT DISTINCT ip_src, COUNT(iphdr.cid), ".
             "MAX(ip_src0), MAX(ip_src1), MAX(ip_src2), MAX(ip_src3) ".
             "FROM iphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (iphdr.sid=acid_ag_alert.ag_sid AND iphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY ip_src ORDER BY ip_src";
   else if ( $chart_type == 7 )
      $sql = "SELECT DISTINCT ip_dst, COUNT(iphdr.cid), ".
             "MAX(ip_dst0), MAX(ip_dst1), MAX(ip_dst2), MAX(ip_dst3) ".
             "FROM iphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (iphdr.sid=acid_ag_alert.ag_sid AND iphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY ip_dst ORDER BY ip_dst";

   if ( $debug_mode > 0)  echo $sql."<BR>";

   
   $result = $db->acidExecute($sql);

   $cnt = 0;
   while ( $myrow = $result->acidFetchRow() )
   {
      if ( $myrow[1] >= $min_threshold )
      {
         $xdata[$cnt][0] = $myrow[2].".".$myrow[3].".".$myrow[4].".".$myrow[5]; 
         $xdata[$cnt][1] = $myrow[1]; 
         ++$cnt;
      }
   }

   $result->acidFreeRows();
   return $cnt;
}

function GetPortDataSet(&$xdata, $chart_type, $data_source, $min_threshold)
{
  GLOBAL $db, $debug_mode;

   if ( $debug_mode > 0 )
   {
      echo "chart_type = $chart_type<BR>
            data_source = $data_source<BR>";
   }

   if ( $chart_type == 8 ) 
      $sql = "SELECT DISTINCT udp_dport, COUNT(udphdr.cid) ".
             "FROM udphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (udphdr.sid=acid_ag_alert.ag_sid AND udphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY udp_dport ORDER BY udp_dport";
   if ( $chart_type == 10 ) 
      $sql = "SELECT DISTINCT udp_sport, COUNT(udphdr.cid) ".
             "FROM udphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (udphdr.sid=acid_ag_alert.ag_sid AND udphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY udp_sport ORDER BY udp_sport";
   else if ( $chart_type == 9 )
      $sql = "SELECT DISTINCT tcp_dport, COUNT(tcphdr.cid) ".
             "FROM tcphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (tcphdr.sid=acid_ag_alert.ag_sid AND tcphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY tcp_dport ORDER BY tcp_dport";
   else if ( $chart_type == 11 )
      $sql = "SELECT DISTINCT tcp_sport, COUNT(tcphdr.cid) ".
             "FROM tcphdr ".
             "INNER JOIN acid_ag_alert ".
             "ON (tcphdr.sid=acid_ag_alert.ag_sid AND tcphdr.cid=acid_ag_alert.ag_cid) ".
             "WHERE ag_id = $data_source GROUP BY tcp_sport ORDER BY tcp_sport";

   if ( $debug_mode > 0)  echo $sql."<BR>";
   //die();
   
   $result = $db->acidExecute($sql);

   $cnt = 0;
   while ( $myrow = $result->acidFetchRow() )
   {
      if ( $myrow[1] >= $min_threshold )
      {
         $xdata[$cnt][0] = $myrow[0]; 
         $xdata[$cnt][1] = $myrow[1]; 
         ++$cnt;
      }
   }

   $result->acidFreeRows();
   return $cnt;
}

?>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<!-- Analysis Console for Incident Databases (ACID) <?php echo $ACID_VERSION; ?> -->
<HTML>
  <HEAD>
    <META name="Author" content="Roman Danyliw">
    <TITLE>ACID: Graph Alert Data</TITLE>
  <LINK rel="stylesheet" type="text/css" href="acid_style.css">

</HEAD>

<BODY>

<TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=5>
<TR>
  <TD class="mainheader">
     <?php
       include("acid_hdr1.html");
     ?>
  </TD>
  <TD class="mainheadertitle">Graph Alert data</TD>
  <TD class="mainheader" ALIGN=RIGHT>
     <?php
       include("acid_hdr2.html");
     ?>
  </TD>

</TR>
</TABLE>
<P><P>

<?php
  LoadGraphingLib($ChartLib_path);
?>

<FORM ACTION="acid_graph_main.php" METHOD="post">

<TABLE WIDTH="100%" BORDER=2 BGCOLOR="#CCCC99">
  <TR>
     <TD>
<?php

  /* Set default chart values */
  if ( $submit == "" )
  {
     $height = 400;
     $width = 400;
     $chart_title = "ACID Chart";
     $min_size = 0;
  }

  /* Connect to the Alert database */
  $db = NewACIDDBConnection($DBlib_path, $DBtype);
  $db->acidPConnect($alert_dbname, $alert_host, $alert_port, $alert_user, $alert_password);

  echo '<B>Chart Title:</B> &nbsp;
            <INPUT TYPE="text" NAME="chart_title" SIZE=60 VALUE="'.$chart_title.'"><BR>'; 
  echo '<B>Data Source:</B> &nbsp;
        <SELECT NAME="data_source">
         <OPTION VALUE=" " '.chk_select($data_source, " ").'>{ data source (AG) }';

  $temp_sql = "SELECT ag_id, ag_name FROM acid_ag";
  $tmp_result = $db->acidExecute($temp_sql);
  if ( ( $tmp_result ) )
  {
     while ( $myrow = $tmp_result->acidFetchRow() )
       echo '<OPTION VALUE="'.$myrow[0].'" '.chk_select($data_source, $myrow[0]).'>'.
            '['.$myrow[0].'] '.$myrow[1];

     $tmp_result->acidFreeRows();
  }
  echo '</SELECT>';
  echo '&nbsp;&nbsp;<B>Size:</B>
        &nbsp;<INPUT TYPE="text" NAME="width" SIZE=4 VALUE="'.$width.'">
        &nbsp;<B>x</B>
        &nbsp;<INPUT TYPE="text" NAME="height" SIZE=4 VALUE="'.$height.'"><BR>';
        
  echo '<B>Chart Type:</B>&nbsp;
        <SELECT NAME="chart_type">
         <OPTION VALUE=" "  '.chk_select($chart_type, " ").'>{ chart type }
         <OPTION VALUE="1" '.chk_select($chart_type, "1").'>Time (hour) vs. Number of Alerts
         <OPTION VALUE="2" '.chk_select($chart_type, "2").'>Time (day) vs. Number of Alerts
         <!--<OPTION VALUE="3" '.chk_select($chart_type, "3").'>Time (week) vs. Number of Alerts-->
         <OPTION VALUE="4" '.chk_select($chart_type, "4").'>Time (month) vs. Number of Alerts
         <!--<OPTION VALUE="5" '.chk_select($chart_type, "5").'>Time (year) vs. Number of Alerts-->
         <OPTION VALUE="6" '.chk_select($chart_type, "6").'>Src. IP address vs. Number of Alerts
         <OPTION VALUE="7" '.chk_select($chart_type, "7").'>Dst. IP address vs. Number of Alerts
         <OPTION VALUE="8" '.chk_select($chart_type, "8").'>Dst. UDP Port vs. Number of Alerts
         <OPTION VALUE="10" '.chk_select($chart_type, "10").'>Src. UDP Port vs. Number of Alerts
         <OPTION VALUE="9" '.chk_select($chart_type, "9").'>Dst. TCP Port vs. Number of Alerts
         <OPTION VALUE="11" '.chk_select($chart_type, "11").'>Src. TCP Port vs. Number of Alerts

        </SELECT>';

  echo '<INPUT TYPE="submit" NAME="submit" VALUE="Graph Alerts"><BR>
        <B>Minimum Threshold Value ( &gt;= ):</B> <INPUT TYPE="text" NAME="min_size" SIZE=5 VALUE='.$min_size.'>
        &nbsp;&nbsp;
        <INPUT TYPE="checkbox" NAME="yaxis_scale" VALUE="1">&nbsp;Y-axis logarithmic
        </TD></TR></TABLE>';

  echo '</FORM>

        <P><HR>';

  $data_pnt_cnt = 0;
  /* Error Conditions */
  if ( $submit != "" && $data_source == " " )
     echo '<FONT><B>No AG was selected for the data source</B>.</FONT>';     
  else if ( $submit != "" && $chart_type == " " )
     echo '<FONT><B>No chart type was specified</B>.</FONT>';
  else if ( $data_source == " " )
     echo '<FONT><B>No AG was specified</B>.</FONT>';

  /* Calculate the data set */
  else if ($submit != "")
  {
     unset($xdata);
     unset($xlabel);

     if ( $debug_mode > 1 )  echo "<H3>Starting data import ...</H3>";

     switch ($chart_type)
     {
         case 1:
         case 2:
         case 3:
         case 4:
         case 5:
         {
            $xaxis_label = "Time";
            $yaxis_label = "Alert Occurances";
            $data_pnt_cnt = GetTimeDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 6:  // Src. IP vs. Num Alerts
         {
            $xaxis_label = "Source IP Address";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetIPDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 7:  // Dst. IP vs. Num Alerts
         {
            $xaxis_label = "Destination IP Address";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetIPDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 8:  // UDP Port vs. Num Alerts 
         {
            $xaxis_label = "Dst. UDP Port";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetPortDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 10:  // UDP Port vs. Num Alerts 
         {
            $xaxis_label = "Src. UDP Port";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetPortDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 9:  // TCP Port vs. Num Alerts 
         {
            $xaxis_label = "Dst. TCP Port";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetPortDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
         case 11:  // TCP Port vs. Num Alerts 
         {
            $xaxis_label = "Src. TCP Port";
            $yaxis_label = "Alert Occurances";

            $data_pnt_cnt = GetPortDataSet($xdata, $chart_type, $data_source, $min_size);
            break;
         }
     }

     if ( $data_pnt_cnt > 0 )
     {
        if ( $debug_mode > 0 )   echo "<H3>Dumping data ...</H3>";
        $data_str = "";
        $data_lbl_str = "";
        for ( $i = 0; $i < count($xdata); $i++)
        {
          if ( $debug_mode > 0 )
             echo $xdata[$i][0]." - ".$xdata[$i][1]."<BR>";
          $data_lbl_str = $data_lbl_str."&datalbl".rawurlencode("[$i]")."=".
                                    rawurlencode($xdata[$i][0]);
          $data_str = $data_str."&data".rawurlencode("[$i]")."=".
                            rawurlencode($xdata[$i][1]);
        }

        if ( $debug_mode > 0 )  echo "<H3>Drawing graph ($width x $height)</H3>";

        echo "<CENTER>
              <IMG SRC=\"acid_graph_display.php?width=$width&height=$height".
                      "&title=".rawurlencode($chart_title).
                      "&xaxis_label=".rawurlencode($xaxis_label).
                      "&yaxis_label=".rawurlencode($yaxis_label).
                      "&yaxis_scale=".rawurlencode($yaxis_scale).
                      $data_str.$data_lbl_str."\"></CENTER>";
      }
      else
        echo "<H3>No data points to plot</H3>";
   }

?>


<P>
<TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=5>
<TR>
  <TD class="mainheader">
     <?php
       include("acid_footer.html");
     ?>
  </TD>
</TR>
</TABLE>

</BODY>

